# Copyright 2017 Google Inc.
#
# Licensed under the Apache License, Version 2.0 (the &quot;License&quot;);
# you may not use this file except in compliance with the License.
# You may obtain a copy of the License at
#
#     http://www.apache.org/licenses/LICENSE-2.0
#
# Unless required by applicable law or agreed to in writing, software
# distributed under the License is distributed on an &quot;AS IS&quot; BASIS,
# WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
# See the License for the specific language governing permissions and
# limitations under the License.

# NOTE: This class is auto generated by the swagger code generator program.
# https://github.com/swagger-api/swagger-codegen.git
# Do not edit the class manually.

defmodule GoogleApi.VideoIntelligence.V1.Model.GoogleCloudVideointelligenceV1AnnotateVideoRequest do
  @moduledoc """
  Video annotation request.

  ## Attributes

  - features ([String.t]): Requested video annotation features. Defaults to: `null`.
    - Enum - one of 
  - inputContent (binary()): The video data bytes. If unset, the input video(s) should be specified via &#x60;input_uri&#x60;. If set, &#x60;input_uri&#x60; should be unset. Defaults to: `null`.
  - inputUri (String.t): Input video location. Currently, only [Google Cloud Storage](https://cloud.google.com/storage/) URIs are supported, which must be specified in the following format: &#x60;gs://bucket-id/object-id&#x60; (other URI formats return google.rpc.Code.INVALID_ARGUMENT). For more information, see [Request URIs](/storage/docs/reference-uris). A video URI may include wildcards in &#x60;object-id&#x60;, and thus identify multiple videos. Supported wildcards: &#39;*&#39; to match 0 or more characters; &#39;?&#39; to match 1 character. If unset, the input video should be embedded in the request as &#x60;input_content&#x60;. If set, &#x60;input_content&#x60; should be unset. Defaults to: `null`.
  - locationId (String.t): Optional cloud region where annotation should take place. Supported cloud regions: &#x60;us-east1&#x60;, &#x60;us-west1&#x60;, &#x60;europe-west1&#x60;, &#x60;asia-east1&#x60;. If no region is specified, a region will be determined based on video file location. Defaults to: `null`.
  - outputUri (String.t): Optional location where the output (in JSON format) should be stored. Currently, only [Google Cloud Storage](https://cloud.google.com/storage/) URIs are supported, which must be specified in the following format: &#x60;gs://bucket-id/object-id&#x60; (other URI formats return google.rpc.Code.INVALID_ARGUMENT). For more information, see [Request URIs](/storage/docs/reference-uris). Defaults to: `null`.
  - videoContext (GoogleCloudVideointelligenceV1VideoContext): Additional video context and/or feature-specific parameters. Defaults to: `null`.
  """

  use GoogleApi.Gax.ModelBase

  @type t :: %__MODULE__{
          :features => list(any()),
          :inputContent => any(),
          :inputUri => any(),
          :locationId => any(),
          :outputUri => any(),
          :videoContext =>
            GoogleApi.VideoIntelligence.V1.Model.GoogleCloudVideointelligenceV1VideoContext.t()
        }

  field(:features, type: :list)
  field(:inputContent)
  field(:inputUri)
  field(:locationId)
  field(:outputUri)

  field(
    :videoContext,
    as: GoogleApi.VideoIntelligence.V1.Model.GoogleCloudVideointelligenceV1VideoContext
  )
end

defimpl Poison.Decoder,
  for: GoogleApi.VideoIntelligence.V1.Model.GoogleCloudVideointelligenceV1AnnotateVideoRequest do
  def decode(value, options) do
    GoogleApi.VideoIntelligence.V1.Model.GoogleCloudVideointelligenceV1AnnotateVideoRequest.decode(
      value,
      options
    )
  end
end

defimpl Poison.Encoder,
  for: GoogleApi.VideoIntelligence.V1.Model.GoogleCloudVideointelligenceV1AnnotateVideoRequest do
  def encode(value, options) do
    GoogleApi.Gax.ModelBase.encode(value, options)
  end
end
