# Copyright 2017 Google Inc.
#
# Licensed under the Apache License, Version 2.0 (the &quot;License&quot;);
# you may not use this file except in compliance with the License.
# You may obtain a copy of the License at
#
#     http://www.apache.org/licenses/LICENSE-2.0
#
# Unless required by applicable law or agreed to in writing, software
# distributed under the License is distributed on an &quot;AS IS&quot; BASIS,
# WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
# See the License for the specific language governing permissions and
# limitations under the License.

# NOTE: This class is auto generated by the swagger code generator program.
# https://github.com/swagger-api/swagger-codegen.git
# Do not edit the class manually.

defmodule GoogleApi.VideoIntelligence.V1.Model.GoogleCloudVideointelligenceV1SpeechTranscriptionConfig do
  @moduledoc """
  Config for SPEECH_TRANSCRIPTION.

  ## Attributes

  - audioTracks ([integer()]): *Optional* For file formats, such as MXF or MKV, supporting multiple audio tracks, specify up to two tracks. Default: track 0. Defaults to: `null`.
  - diarizationSpeakerCount (integer()): *Optional* If set, specifies the estimated number of speakers in the conversation. If not set, defaults to &#39;2&#39;. Ignored unless enable_speaker_diarization is set to true. Defaults to: `null`.
  - enableAutomaticPunctuation (boolean()): *Optional* If &#39;true&#39;, adds punctuation to recognition result hypotheses. This feature is only available in select languages. Setting this for requests in other languages has no effect at all. The default &#39;false&#39; value does not add punctuation to result hypotheses. NOTE: \&quot;This is currently offered as an experimental service, complimentary to all users. In the future this may be exclusively available as a premium feature.\&quot; Defaults to: `null`.
  - enableSpeakerDiarization (boolean()): *Optional* If &#39;true&#39;, enables speaker detection for each recognized word in the top alternative of the recognition result using a speaker_tag provided in the WordInfo. Note: When this is true, we send all the words from the beginning of the audio for the top alternative in every consecutive responses. This is done in order to improve our speaker tags as our models learn to identify the speakers in the conversation over time. Defaults to: `null`.
  - enableWordConfidence (boolean()): *Optional* If &#x60;true&#x60;, the top result includes a list of words and the confidence for those words. If &#x60;false&#x60;, no word-level confidence information is returned. The default is &#x60;false&#x60;. Defaults to: `null`.
  - filterProfanity (boolean()): *Optional* If set to &#x60;true&#x60;, the server will attempt to filter out profanities, replacing all but the initial character in each filtered word with asterisks, e.g. \&quot;f***\&quot;. If set to &#x60;false&#x60; or omitted, profanities won&#39;t be filtered out. Defaults to: `null`.
  - languageCode (String.t): *Required* The language of the supplied audio as a [BCP-47](https://www.rfc-editor.org/rfc/bcp/bcp47.txt) language tag. Example: \&quot;en-US\&quot;. See [Language Support](https://cloud.google.com/speech/docs/languages) for a list of the currently supported language codes. Defaults to: `null`.
  - maxAlternatives (integer()): *Optional* Maximum number of recognition hypotheses to be returned. Specifically, the maximum number of &#x60;SpeechRecognitionAlternative&#x60; messages within each &#x60;SpeechTranscription&#x60;. The server may return fewer than &#x60;max_alternatives&#x60;. Valid values are &#x60;0&#x60;-&#x60;30&#x60;. A value of &#x60;0&#x60; or &#x60;1&#x60; will return a maximum of one. If omitted, will return a maximum of one. Defaults to: `null`.
  - speechContexts ([GoogleCloudVideointelligenceV1SpeechContext]): *Optional* A means to provide context to assist the speech recognition. Defaults to: `null`.
  """

  use GoogleApi.Gax.ModelBase

  @type t :: %__MODULE__{
          :audioTracks => list(any()),
          :diarizationSpeakerCount => any(),
          :enableAutomaticPunctuation => any(),
          :enableSpeakerDiarization => any(),
          :enableWordConfidence => any(),
          :filterProfanity => any(),
          :languageCode => any(),
          :maxAlternatives => any(),
          :speechContexts =>
            list(
              GoogleApi.VideoIntelligence.V1.Model.GoogleCloudVideointelligenceV1SpeechContext.t()
            )
        }

  field(:audioTracks, type: :list)
  field(:diarizationSpeakerCount)
  field(:enableAutomaticPunctuation)
  field(:enableSpeakerDiarization)
  field(:enableWordConfidence)
  field(:filterProfanity)
  field(:languageCode)
  field(:maxAlternatives)

  field(
    :speechContexts,
    as: GoogleApi.VideoIntelligence.V1.Model.GoogleCloudVideointelligenceV1SpeechContext,
    type: :list
  )
end

defimpl Poison.Decoder,
  for:
    GoogleApi.VideoIntelligence.V1.Model.GoogleCloudVideointelligenceV1SpeechTranscriptionConfig do
  def decode(value, options) do
    GoogleApi.VideoIntelligence.V1.Model.GoogleCloudVideointelligenceV1SpeechTranscriptionConfig.decode(
      value,
      options
    )
  end
end

defimpl Poison.Encoder,
  for:
    GoogleApi.VideoIntelligence.V1.Model.GoogleCloudVideointelligenceV1SpeechTranscriptionConfig do
  def encode(value, options) do
    GoogleApi.Gax.ModelBase.encode(value, options)
  end
end
