# Copyright 2017 Google Inc.
#
# Licensed under the Apache License, Version 2.0 (the &quot;License&quot;);
# you may not use this file except in compliance with the License.
# You may obtain a copy of the License at
#
#     http://www.apache.org/licenses/LICENSE-2.0
#
# Unless required by applicable law or agreed to in writing, software
# distributed under the License is distributed on an &quot;AS IS&quot; BASIS,
# WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
# See the License for the specific language governing permissions and
# limitations under the License.

# NOTE: This class is auto generated by the swagger code generator program.
# https://github.com/swagger-api/swagger-codegen.git
# Do not edit the class manually.

defmodule GoogleApi.VideoIntelligence.V1.Model.GoogleCloudVideointelligenceV1p1beta1LabelAnnotation do
  @moduledoc """
  Label annotation.

  ## Attributes

  - categoryEntities ([GoogleCloudVideointelligenceV1p1beta1Entity]): Common categories for the detected entity. E.g. when the label is &#x60;Terrier&#x60; the category is likely &#x60;dog&#x60;. And in some cases there might be more than one categories e.g. &#x60;Terrier&#x60; could also be a &#x60;pet&#x60;. Defaults to: `null`.
  - entity (GoogleCloudVideointelligenceV1p1beta1Entity): Detected entity. Defaults to: `null`.
  - frames ([GoogleCloudVideointelligenceV1p1beta1LabelFrame]): All video frames where a label was detected. Defaults to: `null`.
  - segments ([GoogleCloudVideointelligenceV1p1beta1LabelSegment]): All video segments where a label was detected. Defaults to: `null`.
  """

  use GoogleApi.Gax.ModelBase

  @type t :: %__MODULE__{
          :categoryEntities =>
            list(
              GoogleApi.VideoIntelligence.V1.Model.GoogleCloudVideointelligenceV1p1beta1Entity.t()
            ),
          :entity =>
            GoogleApi.VideoIntelligence.V1.Model.GoogleCloudVideointelligenceV1p1beta1Entity.t(),
          :frames =>
            list(
              GoogleApi.VideoIntelligence.V1.Model.GoogleCloudVideointelligenceV1p1beta1LabelFrame.t()
            ),
          :segments =>
            list(
              GoogleApi.VideoIntelligence.V1.Model.GoogleCloudVideointelligenceV1p1beta1LabelSegment.t()
            )
        }

  field(
    :categoryEntities,
    as: GoogleApi.VideoIntelligence.V1.Model.GoogleCloudVideointelligenceV1p1beta1Entity,
    type: :list
  )

  field(
    :entity,
    as: GoogleApi.VideoIntelligence.V1.Model.GoogleCloudVideointelligenceV1p1beta1Entity
  )

  field(
    :frames,
    as: GoogleApi.VideoIntelligence.V1.Model.GoogleCloudVideointelligenceV1p1beta1LabelFrame,
    type: :list
  )

  field(
    :segments,
    as: GoogleApi.VideoIntelligence.V1.Model.GoogleCloudVideointelligenceV1p1beta1LabelSegment,
    type: :list
  )
end

defimpl Poison.Decoder,
  for: GoogleApi.VideoIntelligence.V1.Model.GoogleCloudVideointelligenceV1p1beta1LabelAnnotation do
  def decode(value, options) do
    GoogleApi.VideoIntelligence.V1.Model.GoogleCloudVideointelligenceV1p1beta1LabelAnnotation.decode(
      value,
      options
    )
  end
end

defimpl Poison.Encoder,
  for: GoogleApi.VideoIntelligence.V1.Model.GoogleCloudVideointelligenceV1p1beta1LabelAnnotation do
  def encode(value, options) do
    GoogleApi.Gax.ModelBase.encode(value, options)
  end
end
